<!-- 现场检测记录列表 -->
<script lang="ts" setup name="FieldTestRecordList">
import type { Ref } from 'vue'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import type { IList, IListQuery } from './approve-interface'
import { printJSON } from '@/utils/printUtils'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { getDictByCode } from '@/api/system/dict'
import type { dictType } from '@/views/device/receive/receive'
import type { IMenu } from '@/components/buttonBox/buttonBox'
import ApprovalDialog from '@/components/Approval/ApprovalDialog.vue'
import ButtonBox from '@/components/buttonBox/buttonBox.vue'
import { delFieldTestApproveList, getFieldTestApproveList, submit } from '@/api/business/fieldTest/apply'
import { SCHEDULE } from '@/utils/scheduleDict'
import { cancelApproval } from '@/api/approval'
const approvalDialog = ref() // 审批对话ref
const $route = useRoute()
const $router = useRouter()
const { proxy } = getCurrentInstance() as any
const TabActiveButton = 'FieldTestRecordList'
const loadingTable = ref(false)
const menu = ref<IMenu[]>([]) // 审批状态按钮组合
const active = ref('') // 右上方按钮
// 查询条件
const listQuery: Ref<IListQuery> = ref({
  approvalStatus: '', // 审批状态类型code
  customerName: '', // 委托方名称
  directorName: '', // 负责人
  formId: SCHEDULE.BUSINESS_FIELDTEST_APPROVE, // 表单id
  siteExecutiveNo: '', // 现场检测编号
  limit: 20,
  offset: 1,
})

// 表头
const columns = ref<TableColumn[]>([
  { text: '现场检测编号', value: 'siteExecutiveNo', align: 'center', width: '160px' },
  { text: '委托方名称', value: 'customerName', align: 'center' },
  { text: '联系人', value: 'deliverer', align: 'center' },
  { text: '电话', value: 'delivererTel', align: 'center' },
  { text: '委托方地址', value: 'customerAddress', align: 'center' },
  { text: '现场测试、校准或检定项目', value: 'executiveItem', align: 'center' },
  { text: '负责人', value: 'directorName', align: 'center' },
  { text: '申请时间', value: 'applyTime', align: 'center', width: '180px' },
  { text: '审批状态', value: 'approvalStatusName', align: 'center', width: '110' },
])
const list = ref<IList[]>([]) // 列表
const total = ref(0) // 数据总条数
// 选中的内容
const checkoutList = ref<string[]>([])

// 多选发生改变时
function handleSelectionChange(e: any) {
  checkoutList.value = e.map((item: { id: string }) => item.id)
}

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  // 模拟数据
  getFieldTestApproveList(listQuery.value).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}
// 清除条件
const clearList = () => {
  listQuery.value = {
    approvalStatus: active.value, // 申请状态
    customerName: '', // 委托方名称
    directorName: '', // 负责人
    formId: SCHEDULE.BUSINESS_FIELDTEST_APPROVE, // 表单id
    siteExecutiveNo: '', // 现场检测编号
    limit: 20,
    offset: 1,
  }
  fetchData()
}
// 搜索
const searchList = () => {
  fetchData(true)
}

// 新建
const add = () => {
  $router.push({
    path: '/fieldTest/approve/add',
  })
}

// 打印
const printList = () => {
  // 打印列
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (checkoutList.value.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, '现场检测审批列表')
  }
  else if (checkoutList.value.length > 0) {
    const printList = list.value.filter((item: IList) => checkoutList.value.includes(item.id))
    printJSON(printList, properties, '现场检测审批列表')
  }
  else {
    ElMessage.warning('无可打印内容')
  }
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}

// 操作
const handleEdit = (row: IList, val: string, title = '') => {
  if (val === '取消') {
    const params = {
      processInstanceId: row.processId!,
      comments: '',
    }
    ElMessageBox.confirm(
      '确认取消该审批吗？',
      '提示',
      {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
      },
    )
      .then(() => {
        cancelApproval(params).then((res) => {
          ElMessage({
            type: 'success',
            message: '取消成功',
          })
          fetchData(true)
        })
      })
  }
  else if (val === '删除') {
    ElMessageBox.confirm(
      '确认删除吗？',
      '提示',
      {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
      },
    )
      .then(() => {
        delFieldTestApproveList({ ids: [row.id] }).then((res) => {
          ElMessage({
            type: 'success',
            message: '删除成功',
          })
          fetchData(true)
        })
      })
  }
  else if (val === '提交') {
    ElMessageBox.confirm(
      '确认提交该审批吗？',
      '提示',
      {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
      },
    )
      .then(() => {
        submit({ id: row.id, formId: SCHEDULE.BUSINESS_FIELDTEST_APPROVE, processId: row.processId }).then((res) => {
          ElMessage({
            type: 'success',
            message: '已提交',
          })
          fetchData(true)
        })
      })
  }
  else if (val === '同意') {
    approvalDialog.value.initDialog('agree', row.taskId)
  }
  else if (val === '驳回') {
    approvalDialog.value.initDialog('reject', row.taskId)
  }
  else if (val === '拒绝') {
    approvalDialog.value.initDialog('refuse', row.taskId)
  }
  else if (val === 'detail' || val === 'edit') { // 详情和编辑
    $router.push({
      path: `/fieldTest/approve/${val}/${row.id}`,
      query: {
        approvalStatusName: row.approvalStatusName, // 审批状态名称
        processId: row.processId, // 流程实例
        decisionItem: row.decisionItem, // 控制同意、驳回、拒绝按钮
        taskId: row.taskId, // 任务id，用于同意、驳回、拒绝审批
      },
    })
  }
}
// 审批结束回调
const approvalSuccess = () => {
  fetchData(true)
}

// 获取字典值
const getDict = async () => {
  // 审批状态
  const res = await getDictByCode('approvalStatus')
  // 制作右上角的菜单
  res.data.forEach((item: dictType) => {
    if (item.name === '全部' || item.name === '草稿箱'
      || item.name === '待审批' || item.name === '审批中'
      || item.name === '已通过' || item.name === '未通过'
      || item.name === '已取消') {
      menu.value.push({
        name: item.name,
        id: `${item.value}`,
      })
    }
  })
}
// 切换tab状态
const changeCurrentButton = (val: string) => {
  active.value = val
  window.sessionStorage.setItem(TabActiveButton, val)
  clearList()
}

onMounted(async () => {
  await getDict()
  if (window.sessionStorage.getItem(TabActiveButton)) {
    active.value = window.sessionStorage.getItem(TabActiveButton)!
  }
  else {
    active.value = menu.value.find(item => item.name === '全部')!.id as string // 全部
  }
})
</script>

<template>
  <div>
    <!-- 布局 -->
    <app-container>
      <search-area :need-clear="true" @search="searchList" @clear="clearList">
        <search-item>
          <el-input v-model.trim="listQuery.siteExecutiveNo" placeholder="现场检测编号" class="short-input" clearable />
        </search-item>
        <search-item>
          <el-input v-model.trim="listQuery.customerName" placeholder="委托方名称" class="short-input" clearable />
        </search-item>
        <search-item>
          <el-input v-model.trim="listQuery.directorName" placeholder="负责人" class="short-input" clearable />
        </search-item>
      </search-area>
      <table-container>
        <template #btns-right>
          <icon-button icon="icon-add" title="新建" type="primary" @click="add" />
          <icon-button icon="icon-print" title="打印" type="primary" @click="printList" />
        </template>
        <normal-table
          :data="list" :total="total" :columns="columns" :query="listQuery" :list-loading="loadingTable"
          is-showmulti-select @change="changePage" @multi-select="handleSelectionChange"
        >
          <template #preColumns>
            <el-table-column label="序号" width="55" align="center">
              <template #default="scope">
                {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
              </template>
            </el-table-column>
          </template>
          <template #columns>
            <el-table-column
              label="操作"
              align="center"
              fixed="right"
              :width="(active === '0') ? 200 : (active === '1' || active === '6') ? 150 : (active === '4' || active === '5' || active === '3') ? 100 : 150"
            >
              <template #default="{ row }">
                <el-button
                  size="small"
                  type="primary"
                  link
                  @click="handleEdit(row, 'detail')"
                >
                  查看
                </el-button>
                <el-button
                  v-if=" row.approvalStatusName === '待审批'"
                  size="small"
                  link
                  type="primary"
                  :disabled="row.approvalStatusName !== '待审批' && row.approvalStatusName !== '审批中'"
                  @click="handleEdit(row, '同意')"
                >
                  同意
                </el-button>
                <el-button
                  v-if=" row.approvalStatusName === '待审批' && row.decisionItem !== 3"
                  size="small"
                  link
                  type="primary"
                  :disabled="row.approvalStatusName !== '待审批' && row.approvalStatusName !== '审批中'"
                  @click="handleEdit(row, '驳回')"
                >
                  驳回
                </el-button>
                <el-button
                  v-if=" row.approvalStatusName === '待审批' && row.decisionItem !== 2"
                  size="small"
                  link
                  type="danger"
                  :disabled="row.approvalStatusName !== '待审批' && row.approvalStatusName !== '审批中'"
                  @click="handleEdit(row, '拒绝')"
                >
                  拒绝
                </el-button>
                <el-button
                  v-if="row.approvalStatusName === '未通过-驳回' || row.approvalStatusName === '草稿箱' || row.approvalStatusName === '已取消'"
                  size="small"
                  link
                  type="primary"
                  @click="handleEdit(row, 'edit')"
                >
                  编辑
                </el-button>
                <el-button
                  v-if="row.approvalStatusName === '草稿箱' || row.approvalStatusName === '已取消'"
                  size="small"
                  link
                  type="primary"
                  @click="handleEdit(row, '提交')"
                >
                  提交
                </el-button>
                <!-- 是发起者且审批中可以取消 -->
                <el-button
                  v-if="row.approvalStatusName === '审批中'"
                  size="small"
                  link
                  type="info"
                  :disabled="row.approvalStatusName !== '审批中'"
                  @click="handleEdit(row, '取消')"
                >
                  取消
                </el-button>
                <el-button
                  v-if="row.approvalStatusName !== '未通过' && row.approvalStatusName !== '已通过' && row.approvalStatusName !== '未通过-驳回' && row.approvalStatusName !== '审批中' && row.approvalStatusName !== '待审批'"
                  size="small"
                  link
                  type="danger"
                  :disabled="row.approvalStatusName === '未通过' || row.approvalStatusName === '已通过'"
                  @click="handleEdit(row, '删除')"
                >
                  删除
                </el-button>
              </template>
            </el-table-column>
          </template>
        </normal-table>
      </table-container>
      <approval-dialog ref="approvalDialog" @on-success="approvalSuccess" />
      <button-box :active="active" :menu="menu" @changeCurrentButton="changeCurrentButton" />
    </app-container>
  </div>
</template>
